﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using XServer2;

namespace XLocate2
{
    public partial class XLocate2 : Form
    {
        XServer2.XLocate svcLocate = new XLocate() {
            Credentials = new System.Net.NetworkCredential("xtok",Properties.Settings.Default.TOKEN),
            Url = Properties.Settings.Default.xLocate2_Url
        };

        public XLocate2()
        {
            InitializeComponent();
            tbxSearchByText_text.Text = Properties.Settings.Default.Text;
            tbxInCountry.Text = Properties.Settings.Default.Country;
            tbxInState.Text = Properties.Settings.Default.State;
            tbxInPostalcode.Text = Properties.Settings.Default.PostalCode;
            tbxInCity.Text = Properties.Settings.Default.City;
            tbxInDistrict.Text = Properties.Settings.Default.District;
            tbxInSubDistrict.Text = Properties.Settings.Default.Subdistrict;
            tbxInStreet.Text = Properties.Settings.Default.Street;
            tbxInHouseNumber.Text = Properties.Settings.Default.HouseNumber;


        }

        private void careForResult(LocationsResponse res)
        {
            dgvResult.DataSource = res.results.Select(hit => new {
                hit?.location?.formattedAddress,
                hit.location.address.country,
                hit.location.address.state,
                hit.location.address.postalCode,
                hit.location.address.city,
                hit.location.address.district,
                hit.location.address.subdistrict,
                hit.location.address.street,
                hit.location.address.houseNumber,
                totalScore = hit.matchQuality.totalScore = hit.matchQuality.totalScore,
                hit.type,
                referenceCoordinate_x = hit.location?.referenceCoordinate?.x,
                referenceCoordinate_y = hit.location?.referenceCoordinate?.y,
                roadAccessCoordinate_x = hit.location?.roadAccessCoordinate?.x,
                roadAccessCoordinate_y = hit.location?.roadAccessCoordinate?.y,
                addressScores_country = hit.matchQuality.addressScores.countrySpecified ? hit.matchQuality.addressScores.country.ToString() : "",
                addressScores_state = hit.matchQuality.addressScores.stateSpecified ? hit.matchQuality.addressScores.state.ToString() : "",
                addressScores_postalCode = hit.matchQuality.addressScores.postalCodeSpecified ? hit.matchQuality.addressScores.postalCode.ToString() : "",
                addressScores_city = hit.matchQuality.addressScores.citySpecified ? hit.matchQuality.addressScores.city.ToString() : "",
                addressScores_district = hit.matchQuality.addressScores.districtSpecified ? hit.matchQuality.addressScores.district.ToString() : "",
                addressScores_subdistrict = hit.matchQuality.addressScores.subdistrictSpecified ? hit.matchQuality.addressScores.subdistrict.ToString() : "",
                addressScores_street = hit.matchQuality.addressScores.streetSpecified ? hit.matchQuality.addressScores.street.ToString() : "",
                addressScores_houseNumber = hit.matchQuality.addressScores.houseNumberSpecified ? hit.matchQuality.addressScores.houseNumber.ToString() : "",
            }).ToArray();
           
        }


        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                SearchByTextRequest req = new SearchByTextRequest()
                {
                    text = tbxSearchByText_text.Text,
                    coordinateFormat = "EPSG:76131" // PTV_MERCATOR
                };

                LocationsResponse res = svcLocate.searchLocations(req);
                careForResult(res);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void btnSearchByAddress_Click(object sender, EventArgs e)
        {
            Address inAddress = new Address()
            {
                country = tbxInCountry.Text,
                state = tbxInState.Text,
                postalCode = tbxInPostalcode.Text,
                city = tbxInCity.Text,
                district = tbxInDistrict.Text,
                subdistrict= tbxInSubDistrict.Text,
                street = tbxInStreet.Text,
                houseNumber = tbxInHouseNumber.Text
            };
            try
            {
                SearchByAddressRequest req = new SearchByAddressRequest()
                {
                    address = inAddress,
                    coordinateFormat = "EPSG:76131"
                };
                LocationsResponse res = svcLocate.searchLocations(req);
                careForResult(res);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
    }
}
